#!/usr/bin/env python

### This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import sos.plugintools

# Class name must be the same as file name and method names must not change
class ocfs2(sos.plugintools.PluginBase):
    def setup(self):
        self.collectExtOutput("service o2cb status", suggest_filename="o2cb.status")
        self.collectExtOutput("service ocfs2 status", suggest_filename="ocfs2.status")
        self.collectExtOutput("mounted.ocfs2 -d", suggest_filename="mounted.ocfs2-d" )
        self.collectExtOutput("mounted.ocfs2 -f", suggest_filename="mounted.ocfs2-f")
        self.collectExtOutput("cat /etc/ocfs2/cluster.conf", suggest_filename="ocfs2.cluster.conf")
        self.collectExtOutput("/bin/rpm -qa | /bin/egrep -e kernel.*`uname -r`", suggest_filename="kernel.rpms.version")
        self.collectExtOutput("/bin/rpm -qa | /bin/egrep -e ocfs.*`uname -r`", suggest_filename="ocfs2.rpm.version")
        self.collectExtOutput("/sbin/fdisk -l", suggest_filename= "fdisk")
        return
