#!/usr/bin/env python

### This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import sos.plugintools

# Class name must be the same as file name and method names must not change
class ovm3(sos.plugintools.PluginBase):
    def setup(self):
	self.collectExtOutput("service o2cb status", suggest_filename="o2cb.status")
        self.collectExtOutput("service ocfs2 status", suggest_filename="ocfs2.status")
        self.collectExtOutput("service ntpd status", suggest_filename="ntpd.status")
	self.collectExtOutput("xm list", suggest_filename="xm.list")
        self.collectExtOutput("xm dmesg", suggest_filename="xm.dmesg")
        self.collectExtOutput("xenpm get-cpuidle-states", suggest_filename="xenpm.get-cpuidle-states")
        self.collectExtOutput("xenpm get-cpufreq-states", suggest_filename="xenpm.get-cpufreq-states")
        self.collectExtOutput("xenpm get-cpuidle-states | grep total | uniq", suggest_filename="get_cpuidle_states_uniq")
        self.collectExtOutput("xenpm get-cpufreq-para", suggest_filename="xenpm.get-cpufreq-para")
        self.collectExtOutput(" dmidecode |grep -i vmware", suggest_filename="vmware-check")
        self.collectExtOutput("xm sched-credit", suggest_filename="xm.sched-credit")
        self.collectExtOutput("xenstore-ls", suggest_filename="xenstore-ls")
        self.collectExtOutput("service xend status", suggest_filename="xend.status")
        self.collectExtOutput("dominfo -c -f", suggest_filename="dominfo-c-f")
        self.collectExtOutput("dom0memcontroller --dumpMemInfo", suggest_filename="dom0memcontroller--dumpMemInfo")
        self.collectExtOutput("cat /OVS/Repositories/*/.ovsrepo", suggest_filename="ovsrepo")
        self.collectExtOutput("cat /poolfsmnt/*/.ovspoolfs", suggest_filename="ovspoolfs")
        self.collectExtOutput("for i in cat /OVS/Repositories/*/VirtualMachines/*/vm.cfg; do cat $i;echo '===============================';done", suggest_filename="xm.cfgs")
        self.collectExtOutput("rpm -qa | grep -E \(xen\|ovs\|ocfs\) | sort", suggest_filename="rpm_qa_xen_ovs_ocfs")
        self.collectExtOutput("echo $ORACLE_HOME", suggest_filename="ORACLE_HOME")
        self.collectExtOutput("echo $ORACLE_SID", suggest_filename="ORACLE_SID")
        self.collectExtOutput("dominfo -c -f", suggest_filename="dominfo-c-f")
	# Virtual Disks
	self.collectExtOutput("ls -l /OVS/Repositories/*/VirtualDisks", suggest_filename="listvdisks")
	# List file systems
        self.collectExtOutput("ls -l -R /OVS", suggest_filename="ls-l-R_OVS")
        self.collectExtOutput("ls -l -R /poolfsmnt", suggest_filename="ls-l-R_poolfsmnt")
        self.collectExtOutput("ls -l -R /nfsmnt", suggest_filename="ls-l-R_nfsmnt")
	self.collectExtOutput("ls -l -R /dlm", suggest_filename="ls-l-R-dlm")
	# XEN network information
        self.collectExtOutput("brctl show", suggest_filename="brctl.show")
        self.collectExtOutput("brctl show | egrep  '[[:digit:]]{1,3}\.[[:digit:]]{1,3}\.[[:digit:]]{1,3}\.[[:digit:]]{1,3}' | awk '{print $1}' | xargs -l brctl showmacs", suggest_filename="brctl.showmacs")
        self.collectExtOutput("ip -s -s -s link show", suggest_filename="ip-s-s-s-link-show")
        self.collectExtOutput("ip address show", suggest_filename="ip-address-show")
	# Misc data
        self.collectExtOutput("ps -elfy", suggest_filename="ps-elfy")
	# ovs-agent-db
	self.collectExtOutput("/usr/sbin/ovs-agent-db dump_db server", suggest_filename="dump_db_server")
	self.collectExtOutput("/usr/sbin/ovs-agent-db dump_db aproc", suggest_filename="dump_db_aproc")
	self.collectExtOutput("/usr/sbin/ovs-agent-db dump_db repository", suggest_filename="dump_db_repository")
	self.collectExtOutput("/usr/sbin/ovs-agent-db -c dump_db server_pool",suggest_filename="dump_db_serverpool")
	self.collectExtOutput("/usr/sbin/ovs-agent-db -c dump_db server_pool_servers",suggest_filename="dump_db_server_pool_servers")
	self.collectExtOutput("/usr/sbin/ovs-agent-db -c dump_db monitored_vms",suggest_filename="dump_db_monitored_vms")
	# NTP Information
        self.collectExtOutput("ntpq -pn", suggest_filename="ntpq_-pn")
        self.collectExtOutput("pgrep ntpd", suggest_filename="pgrep_ntpd")
        self.collectExtOutput("netstat -tulpn | grep 123", suggest_filename="netstat_-tulpn_|_grep_123")
        self.collectExtOutput("date", suggest_filename="date")
        self.addCopySpec("/etc/ntp.conf")
	# Get files
	self.addCopySpec("/u01/app/oracle/ovm-manager-3/.config")
        self.addCopySpec("/etc/ovs-agent")
        self.addCopySpec("/etc/ovs-config")
        self.addCopySpec("/etc/ovs-info")
        self.addCopySpec("/etc/ovs-release")
        self.addCopySpec("/var/log/ovs-agent.log*")
        self.addCopySpec("/var/log/ovmwatch.log*")
        self.addCopySpec("/var/log/ovm-consoled.log*")
        self.addCopySpec("/var/log/osc.log*")
        self.addCopySpec("/var/log/deamon.log*")
        self.addCopySpec("/u01/app/oracle/ovm-manager-3/machine1/base_adf_domain/servers/AdminServer/logs/AdminServer.log")
        self.addCopySpec("/u01/app/oracle/ovm-manager-3/machine1/base_adf_domain/servers/AdminServer/logs/base_adf_domain.log")
        return
